#include <cstdio>
#include <vector>
#include <utility>
#include <cstring>
#include <iostream>
#include <cstdlib>
#include <queue>
#include <set>

using namespace std;

struct solution{
  pair <int, int> pos;
  
  vector < int > col;
  
  bool operator> ( solution t1 ){
    return col.size() > t1.col.size();
  }
};

const int MAXN = 360;
const int inf = 0;

int a[MAXN][MAXN];
int brC[512], N, C; 
vector < pair < int, int > > vecC[512];

char used[MAXN][MAXN], seen[MAXN][MAXN];
pair < int, int > d[4];
int all;
pair < int, int> root[MAXN][MAXN];
int compSize[MAXN][MAXN];

priority_queue < pair < pair < int, int >, int > > q;
solution ans;
vector < int > v[1 << 18];
set < pair < int, int > > edge;
int usd_root[1 << 18];
int add[MAXN][MAXN];
int TM[1 << 18];

void scan(){
  scanf ( "%d%d", &N, &C );
  
  for ( int i = 0; i < N; ++i )
    for ( int j = 0; j < N; ++j )
      scanf ( "%d", a[i] + j );
}

inline int valid ( int i, int j ){
  return i < N && i >= 0 && j < N && j >= 0;
}

inline int convert ( int i, int j ){
  return i * N + j;
}

inline pair < int, int > deconvert ( int i ){
  return make_pair ( i / N, i % N );
}

long long f ( int tmp ){
     return TM[tmp];
}

void addColour( int curColour ){
  for ( int i = 0; i < vecC[curColour].size(); ++i ){
    brC[ curColour ] -= compSize[vecC[curColour][i].first][vecC[curColour][i].second];
    int tmp = convert ( vecC[curColour][i].first, vecC[curColour][i].second );
    
    for ( int j = 0; j < v[tmp].size(); ++j ){
      int ni = deconvert ( v[tmp][j] ).first, nj = deconvert ( v[tmp][j] ).second;
      
      if ( seen[ni][nj] ) continue;
      vecC[a[ ni ][ nj ]].push_back ( make_pair ( ni, nj ) );
      brC[a[ni][nj]] += compSize[ni][nj];
	
	q.push ( make_pair ( make_pair ( f ( a[ni][nj] ), brC[ a[ni][nj] ] ), a[ni][nj] ) );
	seen[ni][nj] = 1;
    }
  }
  vecC[curColour].erase ( vecC[curColour].begin(), vecC[curColour].end() );
  q.push ( make_pair ( make_pair ( f ( curColour ), brC[curColour] ), curColour ) );
  
}


void erase (){
  memset ( seen, 0, sizeof ( seen ) );
 // memset ( TM, -1, sizeof ( TM ) );
  memset ( brC, 0, sizeof ( brC ) );
  
}

void solve( int iStart, int jStart){
  erase();
  
  pair < int, int > pos = root[iStart][jStart];
  
  iStart = pos.first;
  jStart = pos.second;

  vecC[ a[iStart][jStart] ].push_back (  make_pair ( iStart  , jStart ) );
  brC[a[iStart][jStart]] += compSize[iStart][jStart];
  seen[iStart][jStart] = 1;
  
  q.push ( make_pair (  make_pair ( f ( a[iStart][jStart] ), brC[a[iStart][jStart]] ), a[iStart][jStart] ) ) ;
  
  solution cur;
  cur.pos = make_pair ( iStart, jStart );
  
  int brr = 0;
  
  int tttmp = 0;
  while ( !q.empty() ){
    int j = 1;
    
    pair < pair < int, int > , int > tp = q.top();
    q.pop();
    if ( !tp.first.second ) continue;
    
    //tp.first.first *= -1;
    if ( tp.first.second != brC[ tp.second ] ) continue;
   // if ( tp.first.first != TM[ tp.second ] ) continue;
    j = tp.second;
    //printf ( "%d %d %d\n", tp.first.second, tp.second, tttmp );
    
    addColour ( j );

    if ( brr ) cur.col.push_back ( j );
   // TM[j] = brr++;
    ++brr;
   }
  
  if ( ans > cur || ans.col.size() == 0  ) ans = cur;
  while ( q.size() ) q.pop();
  //printf ( "\n\n" );
}

void init(){
  d[0] = make_pair ( -1, 0 );
  d[1] = make_pair ( 0, -1 );
  d[2] = make_pair ( 1, 0 );
  d[3] = make_pair ( 0, 1 );
}

int cur_used[512][512];

void dfs ( int i, int j, int fi, int fj ){
  cur_used[i][j] = 1;
  root[i][j] = make_pair ( fi, fj );
  int lamp = 0;
  
  for ( int k = 0; k < 4; ++k ){
    int ni = i + d[k].first, nj = j + d[k].second;
    
    if ( !valid ( ni, nj ) ) continue;
    if ( a[ni][nj] != a[i][j] ) lamp= 1;
    if ( cur_used[ni][nj] ) continue;
    if ( a[i][j] == a[ni][nj] ) dfs ( ni, nj, fi, fj );
   // else lamp = 1;
  }
  
  compSize[fi][fj] += 1;
}

priority_queue < pair < int, pair < int, int > > > best;


int make_graph ( int i, int j, int rt ){
  cur_used[i][j] = 1;
  
  for ( int k = 0; k < 4; ++k ){
    int ni = i + d[k].first, nj = j + d[k].second;
    
    if ( !valid ( ni, nj ) ) continue;
    if ( a[ni][nj] != a[i][j] && 
      !edge.count ( make_pair (  rt, convert ( root[ni][nj].first, root[ni][nj].second ) ) ) ){
      v[rt].push_back ( convert ( root[ni][nj].first, root[ni][nj].second ) );
      edge.insert ( make_pair (  rt, convert ( root[ni][nj].first, root[ni][nj].second ) ) );
    }
    
    if ( cur_used[ni][nj] ) continue;
    if ( a[i][j] == a[ni][nj] ) make_graph ( ni, nj, rt );
  }
  
}
void fill(){
  for ( int i = 0; i < N; ++i )
    for ( int j = 0; j < N; ++j )
      if ( !cur_used[i][j] )
	dfs ( i, j, i, j );
  
     
  memset ( cur_used, 0, sizeof ( cur_used ) );
  
  for ( int i = 0; i < N; ++i )
    for ( int j = 0; j < N; ++j )
      if ( !cur_used[i][j] ) {
	make_graph ( i, j, convert ( root[i][j].first, root[i][j].second ) );
	compSize[i][j] = v[ convert ( root[i][j].first, root[i][j].second ) ].size();
      }
           
  for ( int i = 0; i < N; ++i )
    for ( int j = 0; j < N; ++j )
      if ( root[i][j] == make_pair ( i, j ) )
	best.push ( make_pair ( compSize[i][j], root[i][j] ) );

 /* for ( int i = 0; i < N; ++i )
    for ( int j = 0; j < N; ++j )
      if ( root[i][j] == make_pair ( i, j ) ){
	printf ( "( %d, %d ): ", i, j );
	int rt = convert ( i, j );
	
	for ( int k = 0; k < v[rt].size(); ++k )
	  printf ( "( %d, %d ) ", deconvert ( v[rt][k] ).first, deconvert ( v[rt][k] ).second );
	printf ("\n" );
      }*/
 // while ( 1 );
 /*
 for ( int i = 0; i < N; ++i ){
   for ( int j = 0; j < N; ++j )
     printf ( "%d ", compSize[i][j] );
   printf ( "\n" );
 }
 //while ( 1 );
 */
 
}

int main(){
  freopen ( "flood-it.in", "r", stdin );
 freopen ( "flood-it.out", "w", stdout );
  
  init();
  scan();
  fill();
  
  long long maxOp = 3000000;
  
  long long p = maxOp / ( N * N * 20 );

  solve ( N / 2, N / 2 );
  --p;
  
  while ( p -- && ! best.empty()){
    solve ( best.top().second.first, best.top().second.second );
//     printf ( "%d\n", p );
    
    best.pop();
  //  printf ( "qwe\n" );
  //break;
  }
  
  printf ( "%d\n", ans.col.size() );
  printf ( "%d %d\n", ans.pos.first, ans.pos.second );
  
  for ( int i = 0; i < ans.col.size(); ++i )
    printf ( "%d\n", ans.col[i] );
    
}
